uk.ac.starlink.fits

## Class FitsTableBuilder

- java.lang.Object
- - uk.ac.starlink.table.formats.DocumentedTableBuilder
  - - uk.ac.starlink.fits.FitsTableBuilder

- All Implemented Interfaces:
    Documented, DocumentedIOHandler, MultiTableBuilder, TableBuilder

      public class FitsTableBuilder
      extends DocumentedTableBuilder
      implements MultiTableBuilder

  Implementation of the `TableBuilder` interface which gets `StarTable`s from FITS files.

  The table implementation used by uncompressed binary FITS tables stored on disk maps the file into memory (`MappedByteBuffer`) rather than reading the stream as such; this makes table construction very fast and cheap on memory, regardless of storage policy. This behaviour can be inhibited by referring to the file location as a URL (e.g. "file:spec23.fits" rather than "spec23.fits"), which fools the handler into thinking that it can't be mapped.

  Limited support is provided for the HEALPix-FITS convention; the relevant `HealpixTableInfo` table parameters are added, but any BAD_DATA keyword value is ignored, and the 1024-element array-valued column variant of the format is not understood.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `FitsTableBuilder()` Default constructor.
    `FitsTableBuilder(WideFits wide)` Constructor.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static StarTable` | `attemptReadTable(nom.tam.util.ArrayDataInput strm, boolean wantRandom, DataSource datsrc, WideFits wide, long[] pos, StoragePolicy policy)` Reads the next header, and returns a StarTable based on it if it represents a table.
    `boolean` | `canImport(java.awt.datatransfer.DataFlavor flavor)` Returns `true` for a flavor with the MIME type "application/fits".
    `boolean` | `canStream()` Indicates whether this handler can read tables from a stream.
    `boolean` | `docIncludesExample()` Indicates whether the serialization of some (short) example table should be added to the user documentation for this handler.
    `static StarTable` | `findNamedTable(nom.tam.util.ArrayDataInput strm, DataSource datsrc, java.lang.String name, WideFits wide, long[] pos, StoragePolicy policy)` Looks through the HDUs in a given FITS stream and if it finds one which has a given name, attempts to make a table out of it.
    `java.lang.String` | `getFormatName()` Returns "FITS".
    `java.lang.String` | `getXmlDescription()` Returns user-directed documentation in XML format.
    `StarTable` | `makeStarTable(DataSource datsrc, boolean wantRandom, StoragePolicy policy)` Creates a StarTable from a DataSource which refers to a FITS file or stream.
    `TableSequence` | `makeStarTables(DataSource datsrc, StoragePolicy policy)` Constructs a sequence of StarTables based on a given DataSource.
    `void` | `streamStarTable(java.io.InputStream istrm, TableSink sink, java.lang.String extnum)` Reads a FITS table from an input stream and writes it to a sink.

    - ### Methods inherited from class uk.ac.starlink.table.formats.DocumentedTableBuilder

      `getExtensions, looksLikeFile`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface uk.ac.starlink.table.TableBuilder

      `looksLikeFile`

    - ### Methods inherited from interface uk.ac.starlink.table.formats.DocumentedIOHandler

      `matchesExtension, readText, toLink`

- - ### Constructor Detail

    - #### FitsTableBuilder

          public FitsTableBuilder()

      Default constructor.

    - #### FitsTableBuilder

          public FitsTableBuilder(WideFits wide)

      Constructor.
      Parameters:
        `wide` - convention for representing extended columns; use null to avoid use of extended columns

  - ### Method Detail

    - #### getFormatName

          public java.lang.String getFormatName()

      Returns "FITS".
      Specified by:
        `getFormatName` in interface `TableBuilder`
      Returns:
        one-word description of this handler's format

    - #### makeStarTable

          public StarTable makeStarTable(DataSource datsrc,
                                         boolean wantRandom,
                                         StoragePolicy policy)
                                  throws java.io.IOException

      Creates a StarTable from a DataSource which refers to a FITS file or stream. If the source has a position attribute, it will be interpreted in one of two ways:
      - If it's an integer, it will be interpreted as the index of the HDU holding the table. The first HDU is number 0 (though being primary this one can't hold a table), the first extension is number 1, etc.
      - Otherwise it's interpreted as the name of the extension. Either of the forms "EXTNAME" or "EXTNAME-EXTVER" is permitted, where EXTNAME and EXTVER are the values of the corresponding FITS header cards, as per the FITS standard.

      If the EXTNAME happens to be in the form of a positive integer, this means you can't refer to the extension by name. Too bad.

      If there is no position attribute, the first HDU which does hold a table is used.

      Specified by:
        `makeStarTable` in interface `TableBuilder`
      Parameters:
        `datsrc` - the source of the FITS table data
        `wantRandom` - whether a random-access table is preferred
        `policy` - a StoragePolicy object which may be used to supply scratch storage if the builder needs it
      Returns:
        a new StarTable based on `datsrc`, or `null` if it doesn't look like a FITS table
      Throws:
        `TableFormatException` - if the table is not of a kind that can be handled by this handler
        `java.io.IOException` - if an unexpected I/O error occurs during processing

    - #### makeStarTables

          public TableSequence makeStarTables(DataSource datsrc,
                                              StoragePolicy policy)
                                       throws java.io.IOException

      Description copied from interface: `MultiTableBuilder`
      Constructs a sequence of StarTables based on a given DataSource. If the source is not recognised or this object does not know how to make tables from it, then a `TableFormatException` should be thrown. If this builder thinks it should be able to handle the source but an error occurs during processing, an `IOException` can be thrown.

      If the `position` of the data source is not null, then this method should return a sequence containing a single table, the one which would be returned by the `makeStarTable` method with that position.

      Specified by:
        `makeStarTables` in interface `MultiTableBuilder`
      Parameters:
        `datsrc` - the DataSource containing the table resource
        `policy` - a StoragePolicy object which may be used to supply scratch storage if the builder needs it
      Returns:
        an array of StarTables read from `datsrc`
      Throws:
        `TableFormatException` - if the table is not of a kind that can be handled by this handler
        `java.io.IOException` - if an unexpected I/O error occurs during processing

    - #### canImport

          public boolean canImport(java.awt.datatransfer.DataFlavor flavor)

      Returns `true` for a flavor with the MIME type "application/fits".
      Specified by:
        `canImport` in interface `TableBuilder`
      Parameters:
        `flavor` - the DataFlavor whose suitability as stream input is to be assessed
      Returns:
        `true` iff this builder reckons it stands a good chance of turning a stream of type `flavor` into a `StarTable`

    - #### streamStarTable

          public void streamStarTable(java.io.InputStream istrm,
                                      TableSink sink,
                                      java.lang.String extnum)
                               throws java.io.IOException

      Reads a FITS table from an input stream and writes it to a sink.
      Specified by:
        `streamStarTable` in interface `TableBuilder`
      Parameters:
        `istrm` - input stream containing the FITS data
        `sink` - destination for table data
        `extnum` - may contain a string representation of the HDU number in which the required table is found (otherwise the first table HDU will be used)
      Throws:
        `TableFormatException` - if the table can't be streamed or the data is malformed
        `java.io.IOException` - if some other error occurs

    - #### canStream

          public boolean canStream()

      Description copied from class: `DocumentedTableBuilder`
      Indicates whether this handler can read tables from a stream.
      Specified by:
        `canStream` in class `DocumentedTableBuilder`
      Returns:
        true iff this handler can read from streams

    - #### docIncludesExample

          public boolean docIncludesExample()

      Description copied from interface: `DocumentedIOHandler`
      Indicates whether the serialization of some (short) example table should be added to the user documentation for this handler. Binary formats, or instances for which the `Documented.getXmlDescription()` method already includes some example output, should return false.
      Specified by:
        `docIncludesExample` in interface `DocumentedIOHandler`
      Returns:
        true if the user documentation would benefit from the addition of an example serialization

    - #### getXmlDescription

          public java.lang.String getXmlDescription()

      Description copied from interface: `Documented`
      Returns user-directed documentation in XML format.

      The output should be a sequence of one or more <P> elements, using XHTML-like XML. Since rendering may be done in a number of contexts however, use of the full range of XHTML elements is discouraged. Where possible, the content should stick to simple markup such as the elements P, A, UL, OL, LI, DL, DT, DD EM, STRONG, I, B, CODE, TT, PRE.

      Specified by:
        `getXmlDescription` in interface `Documented`
      Returns:
        XML description of this object

    - #### findNamedTable

          public static StarTable findNamedTable(nom.tam.util.ArrayDataInput strm,
                                                 DataSource datsrc,
                                                 java.lang.String name,
                                                 WideFits wide,
                                                 long[] pos,
                                                 StoragePolicy policy)
                                          throws nom.tam.fits.FitsException,
                                                 java.io.IOException

      Looks through the HDUs in a given FITS stream and if it finds one which has a given name, attempts to make a table out of it. The supplied `name` is checked against the EXTNAME header value (if present), and if that fails, against EXTNAME-EXTVER (if EXTVER is present too). Matching is case-insensitive.
      Parameters:
        `strm` - stream to read from, positioned at the start of an HDU (before the header)
        `datsrc` - a DataSource which can supply the data in `strm`
        `name` - target extension name or name-version
        `wide` - convention for representing extended columns; use null to avoid use of extended columns
        `pos` - a 1-element array holding the position in `datsrc` at which `strm` is positioned - it's an array so it can be updated by this routine (sorry)
        `policy` - storage policy, or null for default (normally not used)
      Returns:
        a new table
      Throws:
        `nom.tam.fits.FitsException`
        `java.io.IOException`

    - #### attemptReadTable

          public static StarTable attemptReadTable(nom.tam.util.ArrayDataInput strm,
                                                   boolean wantRandom,
                                                   DataSource datsrc,
                                                   WideFits wide,
                                                   long[] pos,
                                                   StoragePolicy policy)
                                            throws nom.tam.fits.FitsException,
                                                   java.io.IOException

      Reads the next header, and returns a StarTable based on it if it represents a table. If a StarTable is returned, it may not be safe to use the supplied input stream subsequently for other purposes. If the next HDU is some non-table type, `null` is returned and the stream is advanced to the end of that HDU; in this case the stream may continue to be used (e.g. for further calls to this method).

      On exit, the first element of the `pos` array contains the position after the current HDU.

      Parameters:
        `strm` - stream to read from, positioned at the start of an HDU (before the header)
        `wantRandom` - whether a random-access table is preferred
        `datsrc` - a DataSource which can supply the data in `strm`
        `wide` - convention for representing extended columns; use null to avoid use of extended columns
        `pos` - a 1-element array holding the position in `datsrc` at which `strm` is positioned - it's an array so it can be updated by this routine (sorry)
        `policy` - storage policy, or null for default (normally not used)
      Returns:
        a StarTable made from the HDU at the start of `strm` or null
      Throws:
        `nom.tam.fits.FitsException`
        `java.io.IOException`